#! /bin/sh
#-----------------------------------------------------------------
#Shell script to remove Email from new and cur if older than 
#X day 
#-----------------------------------------------------------------
. /etc/sysconfig/clement
LOCK=/tmp/expire.sh.$APPNAME-$VERS.lock
trap "rm -f $LOCK ; exit 1" 1 2 3 15
lockfile -1 $LOCK
#-----------------------------------------------------------------
#setting local ownership
USER=`ls -l $BASE/usr/bin/$APPNAME | tr -s ' ' | cut -d' ' -f3`
GROUP=`ls -l $BASE/usr/bin/$APPNAME | tr -s ' ' | cut -d' ' -f4`
MUID=`id -u $USER`
MGID=`id -g $GROUP`
#-----------------------------------------------------------------
#domain to be covered
#too old  time (in day)
TOOOLD=90
LOG=/var/spool/$APPNAME-$VERS/logs/cleanemail.`date +%Y%m%d`.jrl
#-----------------------------------------------------------------
touch $LOG
chown $USER.$USER $LOG
MAILSDIR=/var/spool/$APPNAME-$VERS/mails/
echo "#----------------------------------" >> $LOG
date >> $LOG
echo "Starting removing old E-mail older than $TOOOLD days" >> $LOG
(
if [ -d $MAILSDIR ] ; then 
 cd $MAILSDIR
 find . -path '*/new/*' -type f -mtime +$TOOOLD -print -exec rm -f {} \; >> $LOG
 find . -path '*/cur/*' -type f -mtime +$TOOOLD -print -exec rm -f {} \; >> $LOG
 fi
echo "Scanning old E-mail completed" >> $LOG
date >> $LOG
echo "#----------------------------------" >> $LOG
)
#-----------------------------------------------------------------
#exiting
rm -f $LOCK
exit 0
