#! /bin/sh
#------------------------------------------------------------
#procedure to generate user directories with preset POP-3
#$1 the action to do
#$2 domain to handle
#input is coming on STDIN with the following format
#userid clear_passwd username
#this shell script MUST be run with the clement ownership
#(usually clement.clement)
#------------------------------------------------------------
PROG=gespas
LOCK=/tmp/$PROG.lock
trap "rm -f $LOCK ; exit 1" 1 2 3 15
lockfile -1 -l 600 $LOCK
if [ $# -ne 2 ] ; then
  echo "Parameters are missing, expecting Action AND Domain"
  rm -f $LOCK
  exit;
  fi
#------------------------------------------------------------
#$BASE is used if clement is not used from standard directory
if [ -f $BASE/etc/sysconfig/clement ] ; then
  . $BASE/etc/sysconfig/clement
else
  echo "sysconfig information are missing"
  exit 1;
fi
#------------------------------------------------------------
#ready to start action
#local variable
ACTION=$1
DOMAIN=$2
EXECHOME=`dirname $0`
#local definition
CLMMAIL=$BASE/var/spool/$APPNAME-$VERS/mails/$DOMAIN
OWMBOXES=$BASE/var/spool/$APPNAME-$VERS/owmboxes/$DOMAIN
#------------------------------------------------------------
#Input file format is
#userid:clear_password:user name
#userid will be set to be all lowercase

#setting local ownership
USER=`ls -l $BASE/usr/bin/$APPNAME | tr -s ' ' | cut -d' ' -f3`
GROUP=`ls -l $BASE/usr/bin/$APPNAME | tr -s ' ' | cut -d' ' -f4`
MUID=`id -u $USER`
MGID=`id -g $GROUP`

#reading input file
while read -r LINE
  do
  #lowering userid case
  USRID=`echo $LINE | cut -d':' -f1 | tr '[A-Z]' '[a-z]'`;
  CLEARPASS=`echo $LINE | cut -d':' -f2`;
  USRNAME=`echo $LINE | cut -d':' -f3`;
  case "$ACTION" in
    ADDUSR )		#adding or updating one user
      #creating domain directory for both Clement and OpenWebMail.
      #if needed
      (
      umask 0026
      if [ ! -d $OWMBOXES ] ; then
	mkdir -p $OWMBOXES
	if [ `id -u` = 0 ]; then	#are we root
	  chown $USER.$USER $OWMBOXES
	  fi
	fi
      #taking care of OpenWebMail definition
      #creating the POP3 access By Default
      mkdir -p $OWMBOXES/$USRID/.openwebmail/pop3
      POP3=pop3.$DOMAIN;
      export popasswd=$CLEARPASS;
      POPCRY=`$EXECHOME/calpop.pl $POP3`;
      cd $OWMBOXES/$USRID/.openwebmail/pop3
      touch pop3.book;
        (
        grep -v $POP3 pop3.book;
        /bin/echo $POP3"@@@110@@@0@@@"$USRID@$DOMAIN"@@@"$POPCRY"@@@@0@@@1" ;
        ) > pop3.book.new
      mv -f pop3.book.new pop3.book
      if [ `id -u` = 0 ]; then	#are we root
        chown -R nobody.nobody $OWMBOXES/$USRID
        fi
      )

      #taking care managing user passwd
      (
      export CRYPTED=$CLEARPASS;
      CRYPTED=`$EXECHOME/calpas.pl`;
      cd $CLMMAIL
      grep -v -w ^$USRID .passwd > .passwd.new
      echo "$USRID:$CRYPTED:$MUID:$MGID:$USRNAME::" >> .passwd.new
      if [ `id -u` = 0 ]; then	#are we root
	chown $USER.$USER .passwd.new
	fi
      chmod 0644 .passwd.new
      mv -f .passwd.new .passwd 
      )
      ;;
    REMUSR )		#removing one user
      (
      cd $CLMMAIL
      grep -v -w ^$USRID .passwd > .passwd.new
      if [ `id -u` = 0 ]; then	#are we root
	chown $USER.$USER .passwd.new
	fi
      chmod 0644 .passwd.new
      mv -v .passwd.new .passwd 
      )
      ;;
    DELDOM )		#removing the whole domain
      rm -fr $CLMAIL;
      rm -fr $OWMBOXES;
      ;;
    *)
      echo "$PROG unexpected command"
      exit 1
      ;;
  esac
  done
rm -f $LOCK
