#! /bin/sh
#-------------------------------------------------------------
#program to update password contents 
#date are coming as a line, each line with parameters
#in this order
#userid encrypted_passwd full_username
#-------------------------------------------------------------
PROG=updpas
LOCK=/tmp/$PROG.lock
trap "rm -f $LOCK ; exit 1" 1 2 3 15
lockfile -1 -l 600 $LOCK
if [ $# -ne 2 ] ; then
  echo "Parameters are missing, expecting Action AND Domain"
  rm -f $LOCK
  exit;
  fi
#------------------------------------------------------------
#$BASE is used if clement is not used from standard directory
if [ -f $BASE/etc/sysconfig/clement ] ; then
  . $BASE/etc/sysconfig/clement
else
  echo "sysconfig information are missing"
  exit 1;
fi
#------------------------------------------------------------
#preparing Variable
ACTION=$1
DOMAIN=$2
EXECHOME=`dirname $0`
PWDFILE=$BASE/var/spool/$APPNAME-$VERS/mails/$DOMAIN/.passwd
while read -r USERID CLEARPASS NAME
  do
  case "$ACTION" in
    "ADD"	| \
    "UPD"	)
       export CRYPTED=$CLEARPASS;
       ENCRYPTED=`$EXECHOME/calpas.pl`;
       #adding or updating user within the password file.
       (
       grep -v "^$USERID:" $PWDFILE  
       echo $USERID:$ENCRYPTED:500:500:$NAME::
       )> $PWDFILE.$$.new
       ;;
    "DEL"	)
       #deleting user from the password file
       grep -v "^$USERID:" $PWDFILE  > $PWDFILE.$$.new
       ;;
    "*"		| \
    ""		)
       echo "unknown action"
       ;;
    esac
  if [ -f  $PWDFILE.$$.new ] ; then
    mv $PWDFILE.$$.new $PWDFILE
    fi 
  done
#------------------------------------------------------------
#end of program
rm -f $LOCK
